class AssertionException(Exception) :
	pass

class Reference(object) :
	pass

def TestEnv(report) :
	# create a reference object to share the trace counter
	traceref = Reference()
	traceref.cnt = 0

	def fail() :
		raise AssertionException()

	def assertTrue(expr) :
		if expr :
			pass
		else :
			raise AssertionException()
	
	def trace(cnt, x) :
		assertTrue(traceref.cnt == cnt)
		traceref.cnt = traceref.cnt + 1
		return x
	
	return { "assertTrue" : assertTrue
		   , "trace" : trace
		   , "fail" : fail
		   , "setDescr" : report.setDescr
		   , "expectException" : report.expectException
		   }
