%if style == newcode
\begin{code}
module Attributes where

-- generator attributes
__iter__ = "__iter__"
__next__ = "next"
__send__ = "send"

-- class attributes
__getattribute__ = "__getattribute__"
__getattr__ = "__getattr__"
__setattr__ = "__setattr__"
__delattr__ = "__delattr__"
__bases__ = "__bases__"
__class__ = "__class__"
__metaclass__ = "__metaclass__"
__dict__ = "__dict__"

__new__ = "__new__"
__init__ = "__init__"

__call__ = "__call__"
__nonzero__ = "__nonzero__"
__str__ = "__str__"

-- collection attributes
__delitem__ = "__delitem__"
__setitem__ = "__setitem__"
__getitem__ = "__getitem__"
__len__ = "__len__"
append = "append"

-- operator attributes
__lt__ = "__lt__"
__le__ = "__le__"
__gt__ = "__gt__"
__ge__ = "__ge__"
__eq__ = "__eq__"
__neq__ = "__neq__"

__add__ = "__add__"
__sub__ = "__sub__"
__mul__ = "__mul__"
__div__ = "__div__"
__floordiv__ = "__floordiv__"
__divmod__ = "__mod__"
__pow__ = "__pow__"
\end{code}
%endif

\newcommand{\attr}[1]{\mathtt{\_\_#1\_\_}}
%format __iter__ = "\attr{iter}"
%format __next__ = "\attr{next}"
%format __send__ = "\attr{send}"

%format __getattribute__ = "\attr{getattribute}"
%format __getattr__ = "\attr{getattr}"
%format __setattr__ = "\attr{setattr}"
%format __delattr__ = "\attr{delattr}"
%format __bases__ = "\attr{bases}"
%format __class__ = "\attr{class}"
%format __metaclass__ = "\attr{metaclass}"
%format __dict__ = "\attr{dict}"

%format __new__ = "\attr{new}"
%format __init__ = "\attr{init}"

%format __call__ = "\attr{call}"
%format __nonzero__ = "\attr{nonzero}"
%format __str__ = "\attr{str}"

%format __delitem__ = "\attr{delitem}"
%format __setitem__ = "\attr{setitem}"
%format __getitem__ = "\attr{getitem}"
%format __len__ = "\attr{len}"
%format append = "\mathtt{append}"

%format __lt__ = "\attr{lt}"
%format __le__ = "\attr{le}"
%format __gt__ = "\attr{gt}"
%format __ge__ = "\attr{ge}"
%format __eq__ = "\attr{eq}"
%format __neq__ = "\attr{neq}"

%format __add__ = "\attr{add}"
%format __sub__ = "\attr{sub}"
%format __mul__ = "\attr{mul}"
%format __div__ = "\attr{div}"
%format __divmod__ = "\attr{divmod}"
%format __floordiv__ = "\attr{floordiv}"
%format __pow__ = "\attr{pow}"
%format __neq__ = "\attr{neq}"
